/** 
 IButtonAnchor.java

 * Copyright (C) 2009 by R. Russell Kinter
 *  DeepMatrixIP9 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix IP9 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * This file also uses open-source code of BrowserLauncher2 : 
 * Copyright 2004,2005,2006,2007 Markus Gebhard, Jeff Chapman
 * http://browserlaunch2.sourceforge.net/
 *
 * BrowserLauncher2 is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 */

package matrix.deck;

import edu.stanford.ejalbert.BrowserLauncher;
import edu.stanford.ejalbert.exception.*;
import edu.stanford.ejalbert.exceptionhandler.BrowserLauncherErrorHandler;
//import java.awt.Desktop;
import java.util.*;
import java.io.File;
import java.net.MalformedURLException;
import java.net.URL;

public class IButtonAnchor implements  Runnable {

  /**
     *  New 11-12-05 Holds finished url String for Browserlauncher
     *  
     */
 
  private String commandString = null;

  private String sDirectory = null;
 
  private Cretan CRT;

    /**
     *  New 11-12-05 Thread runner launches the new url.
     */
  private Thread runner = null;

  public IButtonAnchor(){
  CRT = new Cretan(false); 
  start();
   }
	
 public IButtonAnchor( boolean tf, String addy ){ 
  commandString = addy; 
  CRT = new Cretan(false);
  start();
 }	

	 public void setAddress( String addy ){ 
    	 commandString = addy;
    }

  public void openUrl(){
  	 synchronized(CRT){
	  CRT.setCretan(true);
      CRT.notify();
      }
  }

   public void start(){
 if(runner == null ){ 
  runner = new Thread(this); 
   runner.start(); }
  }
   
 public void stop(){
  runner = null;
 }

  public void run(){
 while( Thread.currentThread() == runner ) {
  synchronized(CRT){
try {
if(CRT.getCretan()){
if(commandString!=null){ BrowserLauncher launcher = new BrowserLauncher(); 
launcher.openURLinBrowser(commandString);
}
CRT.wait();
}
else {
CRT.wait(); 
}
}
catch(InterruptedException f){}
catch (BrowserLaunchingInitializingException ex) {  
ex.printStackTrace();  
}    
catch (UnsupportedOperatingSystemException ex) {  
ex.printStackTrace();  
}  
  }
 }
}

}
