/*
  AppFrame2.java

  Copyright (c) 1998 Geometrek and 2009 Russ Kinter
 
 *  This file is part of DeepMatrixIP9.
 *
 *  DeepMatrixIP9 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix IP9 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package matrix.deck;

import java.awt.*;
import java.applet.*;

/**
 * special Frame for Chat if run as a standalone application.
 * closes the window and stops application, if event is received.
 */
public class AppFrame2 extends Frame {
  private Applet app;
  private Image [] img;
  private boolean bLoad = false;
  private int iIMG = 0;
  int iX;
  int iY;
  int iXSize;
  int iYSize;

  public AppFrame2( Applet parent, String title, Image [] IMG, int iX, int iY, int iXSize, int iYSize  ){
    super( title );
    this.app = parent;
    img = IMG;
    this.iX = iX;
    this.iY = iY;
    this.iXSize = iXSize;
    this.iYSize = iYSize; 
    pack();
    setBounds( 32, 8, 960, 512 );
	prepareImage( img[0], app );
    repaint();
    try {
          Thread.sleep(250);
        } 
    catch (InterruptedException ignored) {}
	for( int i = 1; i<img.length; i +=1 ){
	prepareImage( img[i], app ); 
    }
    show();
	    try {
          Thread.sleep(250);
        } 
    catch (InterruptedException ignored) {}
    app.validate();
    this.hide();
    }

  public void paint( Graphics g )  {
    g.drawImage( img[iIMG], iX, iY, iXSize, iYSize, app );
  }

  public void setNewImage( int iIMG ){
   app.hide();
   this.iIMG = iIMG;
   prepareImage( img[iIMG], app); 
   repaint(500);
   app.show();
  }

  public boolean handleEvent( Event evt ){
    if( evt.id == evt.WINDOW_DESTROY ){
      hide();
      return true;
    }
    return false;
  }

  public void goodbye(){
          app.destroy();
      dispose();
      System.exit(0);
  }

 }
