/** 
 MainInterrupt.java

 * Copyright (C) 2009 by R. Russell Kinter
 
 *  This file is part of DeepMatrixIP9. 
 *
 *  DeepMatrixIP9 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix IP9 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * This file also uses open-source code of BrowserLauncher2 : 
 * Copyright 2004,2005,2006,2007 Markus Gebhard, Jeff Chapman
 * http://browserlaunch2.sourceforge.net/
 *
 * BrowserLauncher2 is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 */

package matrix.deck.eai2;

import java.util.*;

public class MainInterrupt implements Runnable {

private Thread thr = null; 
private Thread runner = null;

public MainInterrupt( Thread main ){
  thr = main;
  }	

 public void setInterrupt(){
if(thr!=null&&runner==null){
runner = new Thread(this,"MI");
runner.start();
  }
 }

 public void start(){
 }

 public void stop(){
 runner = null;
 }

 public void run(){
 while( Thread.currentThread() == runner  ){  
 if(!thr.isInterrupted()){
 // System.out.println("MainInterrupt run interrupting: " + thr.getName() );
 thr.interrupt(); runner = null;
   }
 else {
 try{
 runner.sleep(100);
  }
 catch(InterruptedException e ){}
  }
 }

 }


}
