/**
  ObjectListener.java

  Copyright (C) 1998 Gerhard Reitmayr
*/

package tools;

import matrix.deck.*;
import matrix.vrml.*;
import java.io.*;
/**
 * Just listens to RealTimeMessages send to a special ROUTE/Object
 *
 * @version 0.3
 * @author Gerhard Reitmayr
 */
public class ObjectListener implements RealTimeConsumer {
  private String name;
  private boolean bAvatar = false;
  private boolean verbose = false;

  public ObjectListener( String name, boolean verb ){
    this.name = name;
    verbose = verb;
  }

  public boolean getbAvatar(){
  return bAvatar;
  }

   public void objectRoutes( String obj ){
 }

   public void userView( String uv ){
  }

  public void setUserPosition( float[] flt ){
  }

  public void checkPosition( float[] fUP, boolean bUPs  ){
  }

  public String getName(){
    return name;
  }

  public void handleMessage( String tag, Field data ) throws ConsumerException {
    if(!tag.equals(name))
      throw new ConsumerException(name+" matches not "+tag);
    if( verbose )
      System.out.println("RT for "+name);
  }

  public void update(){
  }

  public void beamto( String target ){
 } 

  public void delete(){
  }
}
